unit uClient0; { mk, 25.6.05 bearbeitete Version von cli5 von ics }

interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, Winsock, WSocket, StdCtrls;

type
  TClientForm = class(TForm)
    bConnect: TButton;  bDisconnect: TButton; mEin: TMemo;
    eAdresse: TEdit; ePort: TEdit; lAdresse: TLabel; lPort: TLabel;
    lEin: TLabel; mAus: TMemo; lAus: TLabel; mMeldungen: TMemo;
    lMeldungen: TLabel;  bSenden: TButton;
    procedure bConnectClick(Sender: TObject);
    procedure bDisconnectClick(Sender: TObject);
    procedure SocketDataAvailable(Sender: TObject; Error: Word);
    procedure SocketSessionConnected(Sender: TObject; Error: Word);
    procedure SocketSessionClosed(Sender: TObject; Error: Word);
    procedure bSendenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  public
    socket : TWSocket;
    FError : Word;
  end;

var
  ClientForm: TClientForm;

implementation

{$R *.DFM}

procedure TClientForm.FormCreate(Sender: TObject);
begin
  // Erzeugung
  socket := TWSocket.Create(nil);
  // Verbinden der Ereignis-Behandlungen
  socket.OnSessionConnected := socketSessionConnected;
  socket.OnSessionClosed    := socketSessionClosed;
  socket.OnDataAvailable    := socketDataAvailable;
end;

procedure TClientForm.FormDestroy(Sender: TObject);
begin
  socket.Free;
end;

procedure TClientForm.bConnectClick(Sender: TObject);
begin
  Socket.Addr   := eAdresse.Text;
  Socket.Proto  := 'tcp';
  Socket.Port   := ePort.Text;
  Socket.Connect;              // versuche, Verbindung aufzubauen
  // nach dem effektiven Aufbau wird OnSessionConnected ausgelst
end;

// Ereignis-Behandlung
procedure TClientForm.SocketSessionConnected(Sender: TObject; Error: Word);
begin
  FError := Error;      // Fehlercode merken
  if Error <> 0
  then
    mMeldungen.Lines.Add('keine Verbindung, Fehlernummer: ' + IntToStr(error))

  else
    mMeldungen.Lines.Add('Verbindung steht! Port = '+Socket.GetXPort);
  bDisconnect.Enabled := true;
  bConnect.Enabled    := false;
end;

// Ereignis-Behandlung
procedure TClientForm.SocketDataAvailable(Sender: TObject; Error: Word);
begin
  mEin.Lines.Add(Socket.ReceiveStr);
end;

// Ereignis-Behandlung
procedure TClientForm.SocketSessionClosed(Sender: TObject; Error: Word);
begin
  if FError = 0
  then
    if Error <> 0
    then
      mMeldungen.Lines.Add('Verbindung beendet, Fehlernummer: ' + IntToStr(Error))
    else
      mMeldungen.Lines.Add('Verbindung beendet!');
  bDisconnect.Enabled := false;
  bConnect.Enabled    := true;
end;

procedure TClientForm.bSendenClick(Sender: TObject);
begin
  Socket.Text := mAus.Text;
end;

procedure TClientForm.bDisconnectClick(Sender: TObject);
begin
  Socket.Close;
  // beim effektiven Schluss wird OnSessionClosed ausgelst
end;

end.

